<?php

/*
 * Scheduled snapshot job
 *
 * Copyright (C) 2004 Voluna Software. All rights reserved.
 *
 */

	/* First take a lock so that this program is an exclusive process and no other
	   openfiler code such as the web-interface is also operating at the same time
	   trying to snapshot stuff.
	*/

	$flockp = fopen("/opt/openfiler/var/oflocks/snap.lock", "w+");
	
	if (!$flockp)
		exit;

	if (!flock($flockp, LOCK_EX | LOCK_NB))
	{
		fclose($flockp);
		exit;
	}

	$volumes_id = array();
	$volumes_name = array();
	$volumes_mountpoint = array();
	$volumes_vg = array();
	$volumes_fstype = array();

	function volumes_startelement($parser, $name, $attrs)
	{
		global $volumes_id, $volumes_name, $volumes_mountpoint, $volumes_vg, $volumes_fstype;

		if ($name == "VOLUME")
		{
			array_push($volumes_id, $attrs["ID"]);
			array_push($volumes_name, $attrs["NAME"]);
			array_push($volumes_mountpoint, $attrs["MOUNTPOINT"]);
			array_push($volumes_vg, $attrs["VG"]);
			array_push($volumes_fstype, $attrs["FSTYPE"]);
		}
	}

	function volumes_endelement($parser, $name)
	{
	}
	
	$volumes_parser = xml_parser_create();
	xml_set_element_handler($volumes_parser, "volumes_startelement", "volumes_endelement");
	$volumes_fp = fopen("/opt/openfiler/etc/volumes.xml", "r");

	while ($volumes_data = fread($volumes_fp, 4096))
		xml_parse($volumes_parser, $volumes_data, feof($volumes_fp));
		
	fclose($volumes_fp);
	xml_parser_free($volumes_parser);

	$snapshots_id = array();
	$snapshots_lvname = array();
	$snapshots_vgname = array();
	$snapshots_shared = array();
	$snapshots_rotateid = array();
	
	$schedule_duration = array();
	$schedule_size = array();
	$schedule_share = array();
	$schedule_rotatecount = array();
	$schedule_lvname = array();
	$schedule_vgname = array();

	function snapshots_startelement($parser, $name, $attrs)
	{
		global $snapshots_id, $snapshots_lvname, $snapshots_vgname, $snapshots_shared, $snapshots_rotateid;
		global $schedule_duration, $schedule_size, $schedule_share, $schedule_rotatecount, $schedule_lvname, $schedule_vgname;

		if ($name == "SNAPSHOT")
		{
			array_push($snapshots_id, $attrs["ID"]);
			array_push($snapshots_lvname, $attrs["LVNAME"]);
			array_push($snapshots_vgname, $attrs["VGNAME"]);
			array_push($snapshots_shared, $attrs["SHARED"]);
			array_push($snapshots_rotateid, $attrs["ROTATEID"]);
		}
		else if ($name == "SCHEDULE")
		{
			array_push($schedule_duration, $attrs["INTERVAL"]);
			array_push($schedule_size, $attrs["SIZE"]);
			array_push($schedule_share, $attrs["SHARE"]);
			array_push($schedule_rotatecount, $attrs["ROTATECOUNT"]);
			array_push($schedule_lvname, $attrs["LVNAME"]);
			array_push($schedule_vgname, $attrs["VGNAME"]);
		}
	}

	function snapshots_endelement($parser, $name)
	{
	}
	
	$snapshots_parser = xml_parser_create();
	xml_set_element_handler($snapshots_parser, "snapshots_startelement", "snapshots_endelement");
	$snapshots_fp = fopen("/opt/openfiler/etc/snapshots.xml", "r");

	while ($snapshots_data = fread($snapshots_fp, 4096))
		xml_parse($snapshots_parser, $snapshots_data, feof($snapshots_fp));
		
	fclose($snapshots_fp);
	xml_parser_free($snapshots_parser);

	$fstabp = popen("/usr/bin/sudo /bin/cat /etc/fstab", "r");
	$i = 0;
	while (!feof($fstabp))
	{
		$j = 0;
		$fstabstr = trim(fgets($fstabp, 4096));

		if (strlen($fstabstr) <= 0)
			continue;
		
		if (substr($fstabstr, 0, 1) == "#")
			continue;

		$foo = explode(" ", $fstabstr);
		
		foreach ($foo as $fresultitem)
		{
			$fresultitem = trim($fresultitem);
			if (strlen($fresultitem) > 0)
			{
				$fstab[$i][$j] = $fresultitem;
				$j++;
			}
		}

		$i++;
	}
	
	$fstabcount = $i;
		
	pclose($fstabp);
	
	$vgname = "openfiler";
	


	/* Release the lock */
	
	flock($flockp, LOCK_UN);
	fclose($flockp);
	
?>
